// Name: main.c
// char    MYD_id[]=
// " sphDESC.C Ver.033 2009/11/12  MORIYOSHI DENSHI CO.,LTD. COPYRIGHT(C) MAR.2009 ";
// License: GNU GPL v2
// avr Tiny2313 12MHz

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>
#include <string.h>

#include "hidtermconfig.h"

#include "usbdrv.h" //@
#if (USB_CFG_DESCR_PROPS_UNKNOWN & USB_PROP_IS_DYNAMIC)
static  uchar serbuf[32+0]; // =0; //@
#define SerRoutine 1
#endif

#include "usbdrv.c"

//static uchar reportId;
static uchar offset; // data already processed in current transfer

static uchar usbData[33];
//static uchar page_mode;
#define page_mode GPIOR0

typedef struct shortaddr{
    uchar   lbyte;
    uchar   hbyte;
}shrtaddr_t;

union{
    uchar       bytes[1];
    uint16_t    w;
    shrtaddr_t  b;
}               page_addr;

PROGMEM char usbHidReportDescriptor[33] = {
    0x06, 0x00, 0xff,              // USAGE_PAGE (Generic Desktop)
    0x09, 0x01,                    // USAGE (Vendor Usage 1)
    0xa1, 0x01,                    // COLLECTION (Application)
    0x15, 0x00,                    //   LOGICAL_MINIMUM (0)
    0x26, 0xff, 0x00,              //   LOGICAL_MAXIMUM (255)
    0x75, 0x08,                    //   REPORT_SIZE (8)

    0x85, 0x02,                    //   REPORT_ID (2)
    0x95,    7,                    //   REPORT_COUNT (7)
    0x09, 0x00,                    //   USAGE (Undefined)
    0xb2, 0x02, 0x01,              //   FEATURE (Data,Var,Abs,Buf)

    0x85, 0x04,                    //   REPORT_ID (4)
    0x95,   39,                    //   REPORT_COUNT (39)
    0x09, 0x00,                    //   USAGE (Undefined)
    0xb2, 0x02, 0x01,              //   FEATURE (Data,Var,Abs,Buf)

    0xc0                           // END_COLLECTION
};


#define wait GPIOR1
//static uchar wait; // 60 160
static void delay(uchar d) {
    while(d--);
}

static uint8_t usi_trans(uchar data) {
    USIDR = data;
    USICR |= (1 << USIWM0); //MYD090925
    USISR |= (1 << USIOIF); //MYD090925
    do{
        delay(wait);
        USICR = (1 << USIWM0) | (1 << USICS1) | (1 << USICLK) | (1 << USITC);
    } while(!(USISR & (1 << USIOIF)) );
    return USIDR;
}

uchar   usbFunctionSetup(uchar data[8]) {
usbRequest_t    *rq = (void *)data;
    uchar rval; //MYD091021

    rval=0;
    if(rq->bRequest == USBRQ_HID_SET_REPORT){
//      reportId = rq->wValue.bytes[0]; // store report ID
        offset = 0;
        rval = 0xff;
    }else if(rq->bRequest == USBRQ_HID_GET_REPORT){
        usbMsgPtr = usbData;
        usbData[0] = rq->wValue.bytes[0]; // report ID
        rval = 8;
        if(usbData[0] == 4) {
            rval = 40;
        }
    }
    return rval; //MYD091021 (-6)
}

uchar usbFunctionWrite(uchar *data, uchar len) {
    uchar i;
//  static uchar tcnt; //MYD091021 (-3)
#define tcnt GPIOR2

    if(offset == 0 && !(data[1] & 0x40)) {
//  if(data[1] == 1) // TEST
        usbData[1] = data[2];
        if(data[1] == 2) { // SET_LED
//          PORTD = (PORTD & ~3) | (data[2] & 3);
//          PORTB = (PORTB & ~0x10) | (data[3] & 0x10); // ~reset
//          PORTB = (PORTB & ~0x0C) | ((data[2] << 2) & 0x0C); // ~activeLED ~powerLED
//          PORTB = (PORTB & ~0x1C) | ((data[3] & 0x10) | ((data[2] << 2) & 0x0C));
            USICR = 0; // USI off for RTS (serial port flow control)
            PORTB = data[3];
            //if(data[4] == 0x55) DDRB = data[5]; // (+1)
            if(data[4] & (1<<PB2)) DDRB = data[4];
                else DDRB |= (1<<PB7); // (+3)
            //if(!(PORTB & (1<<PB4))) DDRB |= (1<<PB7); // ~reset Low (+2)
//          UCSRB = data[4]; // USART control, only Face
//          PORTD = data[5]; // only Face
            usbData[2] = PINB; //PIND;
        }else if(data[1] == 18) { // Set wait
            wait = data[2];
        }else if(data[1] == 16) { // SPI
            for(i = 0; i < 4; i++) {
                usbData[i+1] = usi_trans(data[i+2]);
            }
        }else if(data[1] == 20) { // Page set
            page_mode = data[2];
            page_addr.b.hbyte = data[3];
            page_addr.b.lbyte = data[4];
#if SerRoutine & 0
        }else if(data[1] == 22) { //MYD091021 (+6)
            UBRRL = data[2]; // USART baud rate
            UBRRH = data[3];
#endif
        }
    }else{
        if(offset == 0) { // Page buf
            tcnt = (data[1] & 0x07) + 2;
            i = 2;
        }else /* if(!(reportId == 4 && offset < 32)) tcnt = 0; else */ {
            tcnt = (offset > 32-8) ? 32-offset : 8;
            i = 0;
        }
        while(i < tcnt) {
            usi_trans(page_mode);
            usi_trans(page_addr.b.hbyte);
            usi_trans(page_addr.b.lbyte);
            usbData[++offset] = usi_trans(data[i++]);
            if(page_mode & 0x88) { // EEPROM or Flash(P=Hi)
                page_addr.w++;
                page_mode &= ~0x08;
            }else{
                page_mode |= 0x08;
            }
        }
    }
    return 1;
}

#if SerRoutine
#define UsbRetSts serbuf[0]
#define SerRXbuff serbuf[1]
#define UsbwV0    serbuf[16]
#define UsbwV1    serbuf[17]
#define UsbwI0    serbuf[18]
#define UsbwL1    serbuf[21]
#define SerTXbuff serbuf[22]

// use at host(Hub driver) IOCTL_USB_GET_DESCRIPTOR_FROM_NODE_CONNECTION
/*uchar usbFunctionDescriptor(struct usbRequest *rq) { // bRequest==6 GET_DESCRIPTOR
    uchar i, *pser, *prq; pser = &serbuf[16]; prq = &rq->wValue.bytes[0]; i=6;
    do *pser++ = *prq++; while(--i);
//@ serbuf[6+16] = rq->bmRequestType;
//  serbuf[0+16] = rq->wValue.bytes[0];
//  serbuf[1+16] = rq->wValue.bytes[1];
//  serbuf[2+16] = rq->wIndex.bytes[0];
//  serbuf[3+16] = rq->wIndex.bytes[1];
//  serbuf[4+16] = rq->wLength.bytes[0];
//  serbuf[5+16] = rq->wLength.bytes[1];
    usbMsgPtr = serbuf; // &serbuf[16]
    return 7;
}*/

#endif

int main(void) {
    // initialize hardware
    PORTD = (1<<PD0) | (1<<PD6) | (1<<PD5) | (1<<PD2);  // pullup RXD(PD0)
                       // no pullups on USB pins
    DDRD  = ~USBMASK & ~(1<<PD0) & ~(1<<PD6) & ~(1<<PD5) & ~(1<<PD2);
                       // all outputs except USB data and RXD
    PORTB = 0x18;      // no pullup PB5 // ~RST Hi, activeLED off //MYD091012 (-1)
//  DDRB = ~(1<<PB5);  // all outputs except USI input data
    DDRB = (1<<PB6) | (1<<PB4) | (1<<PB3) | (1<<PB2);
#if SerRoutine
//    serInit();
//void serInit() {
    // USART configuration : 9600bps 8N1
//@ UBRRH = 0;
    UBRRL = 78-1;
    UCSRB = (1<<RXEN) | (1<<TXEN);
//@ UsbRetSts = 0;
//@ UsbwV1 = 0;
//}
#endif

    usbInit();
    sei();
    while(1) { // main event loop
        usbPoll();
#if SerRoutine
//      serLoop();
//void serLoop()
{   uchar retStsRX, retStsTX; uchar *dest, *src;
    retStsRX = UsbRetSts & 0x0F;
    retStsTX = UsbRetSts >> 4;

    if(UsbwV1 & 0x80) { uchar i;
        UsbwV1 &= 0x7F;
        if(UsbwV1 == 0x60) {
            retStsTX = 0; PORTB = UsbwV0; // TXbuffer flush & PORTB out
            if(retStsRX < 6) { uchar j;
                j = PINB;
                if(!(PIND & (1<<PD5))) j &= ~(1<<PB4); // (+2)
                serbuf[6] = j;
            }
        }else{
//@         if( /*(i = (UsbwV1 & 0x07)) &&*/ (retStsTX < 7) ) {
            if( (i = (UsbwV1 & 0x07)) && (retStsTX < 7) ) { //@
                UsbwL1 = UsbwV0;
                dest = &SerTXbuff + retStsTX; src = &UsbwI0;
//@             i = UsbwV1 & 0x07;
                retStsTX += i;
                do *dest++ = *src++; while(--i); //@ i--
            }
            PORTB &= ~(1<<PB6); // RTS control (PB6== ~RTS)
            if(retStsRX >= 7) {
                retStsRX -= 6;
                dest = &SerRXbuff; src = &SerRXbuff+6;
lc:             i = 9;
                do *dest++ = *src++; while(--i);
            }else{
                retStsRX = 0;
            }
        }
    }
    if((UCSRA & (1<<RXC)) && (retStsRX < 15)) {
        *(&SerRXbuff + (retStsRX++)) = UDR;
        if( (retStsRX >= 12) && (UsbwV1 & (1<<4)) )
            PORTB |= (1<<PB6); // RTS control (PB6== ~RTS)
    }
    if(retStsTX && (UCSRA & (1<<UDRE)))
//  if(retStsTX && (UCSRA & (1<<UDRE)) && (PIND & (1<<PD5)) ) //MYD091012 (+2)
      if(!(UsbwV1 & (1<<5)) || !(PINB & (1<<PB5)) ) { // CTS control (PB5== ~CTS)
        UDR = SerTXbuff;
        --retStsTX;
        dest = &SerTXbuff; src = &SerTXbuff+1;
        goto lc;
//      i = 9;
//      do *dest++ = *src++; while(--i);
    }

    UsbRetSts = (retStsTX << 4) | retStsRX;
}
#endif
    }
}
