
#ifndef __SFR_OFFSET
#define __SFR_OFFSET 0
#endif
#include "avr/interrupt.h"

#define nop2     rjmp    .+0 /* jump to next instruction */

#define SER_INTR_VECTOR  SIG_USART_RECV // SIG_USART0_RX // SIG_INTERRUPT1 YM
    .text
    .global SER_INTR_VECTOR
    .type   SER_INTR_VECTOR, @function

    .global setdlmnbl

;----------------------------------------------------------------------------
; Utility functions
;----------------------------------------------------------------------------

#define argCh   r22 // argument 2
#define argDpL  r24 // argument 1
#define argDpH  r25 // argument 1
#define resSdL  r24 // result
#define resSdH  r25 // result

; uchar setdlmnbl(uchar *delmt, uchar ch);
setdlmnbl:
    mov     ZH, argDpH  ; r25
    mov     ZL, argDpL  ; r24
    mov     r24, argCh  ; r22
    st      Z, argCh    ; *delmt = ch;
    rcall   nibbl       ; return nibbl(ch);
    ldi     resSdH, 0   ; r25
    ret

;----------------------------------------------------------------------------
; Interrupt code
;----------------------------------------------------------------------------

#define SER_CTS_IOPORTNAME  B
#define CTSBIT              4
#define SER_RTS_IOPORTNAME  B
#define RTSBIT              3
#define SER_CONCAT(a, b)    a ## b
#define SER_OUTPORT(name)   SER_CONCAT(PORT, name)
#define SEROUT              SER_OUTPORT(SER_CTS_IOPORTNAME)
#define SER_INPORT(name)    SER_CONCAT(PIN, name)
#define SERIN               USB_INPORT(SER_RTS_IOPORTNAME)

SER_INTR_VECTOR:
;   push    r24
;   lds     r24, UCSR0A
;   sbrs    r24, RXC0	; if(UCSRA & (1<<RXC))
;   rjmp    intrret
;   sbi     SEROUT, CTSBIT  ; PORTB |= (1<<PB4);
;   lds     r24, UDR0
;   sts     conibf, r24 ; conibf = UDR;
;   ldi     r24, 1
;   sts     consts, r24 ; consts = 1;
;   lds     r24, UCSR0B
;   andi    r24, ~(1<<RXCIE0)
;   sts     UCSR0B, r24
;intrret:
;   pop     r24

    push    r24
    in      r24, SREG
    push    r24
    push    r25
    push    ZH          ; r31
    push    ZL          ; r30
;    push    XH          ; r27
;    push    XL          ; r26
;    push    r23
;    push    r22
;    push    r21
;    push    r20
;    push    r19
;    push    r18
    rcall   rxrdyint0
;    pop     r18
;    pop     r19
;    pop     r20
;    pop     r21
;    pop     r22
;    pop     r23
;    pop     XL
;    pop     XH
    pop     ZL
    pop     ZH
    pop     r25
    pop     r24
    out     SREG, r24
    pop     r24
    reti
